#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <sdktools_entoutput>

public Plugin:myinfo = 
{
	name	= "Health Kit",
	author	= "wS / Schmidt",
	version	= "1.1",
	url		= "http://world-source.ru/"
};

new Handle:kit_hp;
new Handle:kit_model;
new String:g_KitModel[150];

public OnPluginStart()
{
	kit_hp		= CreateConVar("kit_hp", "5", "Сколько HP добавляет аптечка", _, true, 1.0);
	kit_model	= CreateConVar("kit_model", "models/items/healthkit.mdl", "Модель аптечки");

	HookEvent("player_death", player_death);
}

public OnConfigsExecuted()
{
	GetConVarString(kit_model, g_KitModel, 150);
	if (StrContains(g_KitModel, "models") != 0 || StrContains(g_KitModel, ".mdl") < 1)
	{
		strcopy(g_KitModel, 150, "models/items/healthkit.mdl");
	}
	PrecacheModel(g_KitModel, true);
}

public player_death(Handle:event, const String:name[], bool:dontBroadcast)
{
	new killer = GetClientOfUserId(GetEventInt(event, "attacker"));
	if (killer < 1)
		return;

	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (GetClientTeam(killer) == GetClientTeam(client))
		return;

	new ent = CreateEntityByName("prop_physics");
	if (ent < 1)
		return;

	DispatchKeyValue(ent, "model", g_KitModel);
	decl Float:pos[3]; GetClientAbsOrigin(client, pos);
	pos[0] += 35.0; pos[2] += 75.0;
	DispatchKeyValueVector(ent, "origin", pos);
	DispatchKeyValue(ent, "solid", "6");
	DispatchKeyValue(ent, "spawnflags", "18");
	DispatchSpawn(ent);
	HookSingleEntityOutput(ent, "OnBreak", OnBreak);
}

public OnBreak(const String:output[], ent, client, Float:delay)
{
	if (0 < client <= MaxClients)
		SetEntProp(client, Prop_Send, "m_iHealth", GetClientHealth(client) + GetConVarInt(kit_hp));
}